#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

const long double EPS = 1e-8;

int main() {
	int n, q;
	cin >> n >> q;
		
	vector <string> s(n);
	for (int i = 0; i < n; i++)
		cin >> s[i];
	
	while (q--) {
		int u, v, c;
		cin >> u >> v >> c;
		u--, v--;
		int z = s[u].length() - c, x = s[v].length() - c;
		
		long double mx = 0.0, d = 1.0;
		int cnt = 1;
		while (cnt <= min(z, x)) {
			if (s[u][z - cnt] != s[v][x - cnt])
				d *= 0.5;
			
			if (mx + EPS < (long double)(cnt) * d)
				mx = (long double)(cnt) * d;
			
			cnt++;
		}
		
		cout.precision(9);
		cout << fixed << mx << '\n';
	}
	
	return 0;
}