#include "jngen.h"
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

int main(int argc, char* argv[]) {
	parseArgs(argc, argv);
	
	int n = getOpt(0);
	int m = getOpt(1);
	int v = getOpt(2);
	int q = getOpt(3);
	int w = getOpt(4);
	
	cout << n << ' ' << m << ' ' << q << '\n';
	auto g = Graph::random(n, m).directed().acyclic().g();
	for (int i = 0; i < m; i++) {
		int z = rnd.next(1, v);
		int x = rnd.next(1, v);
		string s = to_string(z) + " " + to_string(x);
		g.setEdgeWeight(i, s);
	}
	
	cout << g.add1() << '\n';
	for (int i = 0; i < q; i++) {
		cout << rnd.next(1, w) << ' ';
		cout << rnd.next(1, w) << '\n';
	}
	
	return 0;
}