import functools
import queue
import io, os

input = io.BytesIO(os.read(0,os.fstat(0).st_size)).readline
n, m, q = map(int, input().decode().split())

e = []
for i in range(m):
    u, v, s, w = map(int, input().decode().split())
    u, v = u - 1, v - 1
    e.append([u, v, s, w])

t = []
for i in range(q):
    a, b = map(int, input().decode().split())
    t.append([i, a, b])

def cgf(a, b):
    return a[1] * b[2] - a[2] * b[1]

t.sort(key = functools.cmp_to_key(cgf))

l, r = -1, q
while r - l > 1:
    d = (l + r) // 2
    if d == -1 or d == q:
        break
    g = [[] for i in range(n)]
    for i in range(m):
        if e[i][3] * t[d][2] < e[i][2] * t[d][1]:
            g[e[i][0]].append(e[i][1])
    used = [0 for i in range(n)]
    qu = queue.Queue()
    qu.put(0)
    used[0] = 1
    while not qu.empty():
        v = qu.get()
        dfdf = 0
        for to in g[v]:
            if to == n - 1:
                dfdf = 1
                used[to] = 1
                break
            if used[to] == 0:
                used[to] = 1
                qu.put(to)
        if dfdf == 1:
            break
    if used[n - 1] == 1:
        r = d
    else:
        l = d

ans = ["" for i in range(q)]
for i in range(q):
    if i > l:
        ans[t[i][0]] = "YES"
    else:
        ans[t[i][0]] = "NO"

for s in ans:
    print(s)