/**
 *    author:  tourist
 *    created: 06.10.2022 18:45:25       
**/
#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n, m, q;
  cin >> n >> m >> q;
  vector<vector<array<int, 3>>> g(n);
  vector<int> deg(n);
  for (int i = 0; i < m; i++) {
    int x, y, a, b;
    cin >> x >> y >> a >> b;
    --x; --y;
    g[x].push_back({y, a, b});
    deg[y] += 1;
  }
  vector<int> que;
  for (int i = 0; i < n; i++) {
    if (deg[i] == 0) {
      que.push_back(i);
    }
  }
  for (int b = 0; b < (int) que.size(); b++) {
    for (auto& p : g[que[b]]) {
      int to = p[0];
      if (--deg[to] == 0) {
        que.push_back(to);
      }
    }
  }
  assert((int) que.size() == n);
  vector<pair<int, int>> dp(n, make_pair(0, 1));
  dp[0] = make_pair(1, 0);
  for (int i : que) {
    for (auto& p : g[i]) {
      int to = p[0];
      pair<int, int> val = dp[i];
      if (val.first * 1LL * p[2] > val.second * 1LL * p[1]) {
        val = make_pair(p[1], p[2]);
      }
      if (val.first * 1LL * dp[to].second > val.second * 1LL * dp[to].first) {
        dp[to] = val;
      }
    }
  }
  while (q--) {
    int a, b;
    cin >> a >> b;
    if (dp[n - 1].first * 1LL * a > dp[n - 1].second * 1LL * b) {
      cout << "YES" << '\n';
    } else {
      cout << "NO" << '\n';
    }
  }
  return 0;
}
