#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
	int n;
	long long R;
	
	cin >> n >> R;
	
	vector <long long> a(n + 1), pr(n + 1, 0);
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
		pr[i] = pr[i - 1] + a[i];
	}
	
	for (int i = 1; i <= n; i++) {
		if (a[i] > R) {
			cout << "-1\n";
			continue;
		}
		
		int m = max(i - 1, n - i);
		while (m > 0) {
			long long sum = pr[min(n, i + m)] - pr[max(1, i - m) - 1];
			if (sum <= R) break;
			m--;
		}
		
		cout << m << '\n';
	}
	
	return 0;
}