#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

long long gcd(long long a, long long b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

int main() {
	long long n, d;
	cin >> n;
	
	vector <long long> a(n), p(n);
	
	for (int i = 0; i < n; i++) cin >> a[i];
	for (int i = 0; i < n; i++) {
		cin >> p[i];
		if (i == 1)
			d = gcd(p[0], p[1]);
		if (i > 1)
			d = gcd(d, p[i]);
	}
	
	long long mx = 0;
	for (int i = 0; i < n; i++) {
		p[i] /= d;
		mx = max(mx, a[i] / p[i] + 1);
	}
	
	long long ans = 1e18;
	for (int d = 1; d <= mx; d++) {
		long long cur = 0;
		for (int i = 0; i < n; i++)
			cur += abs(a[i] - d * p[i]);
		ans = min(ans, cur);
	}
	
	cout << ans << '\n';
	
	return 0;
}