#!/usr/bin/env bash
echo "Running 39 checker test(s)"
echo "Running 39 checker test(s)" 1> checker-tests.log
echo "Running test #1" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/01 files/tests/checker-tests/01.o files/tests/checker-tests/01.a 2>> checker-tests.log
if [ "$?" -ne "0" ]; then
    echo "Checker returned incorrect verdict. Expected: OK" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: OK. See checker-tests.log for checker comment"
    read
fi
echo "Running test #2" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/02 files/tests/checker-tests/02.o files/tests/checker-tests/02.a 2>> checker-tests.log
if [ "$?" -ne "0" ]; then
    echo "Checker returned incorrect verdict. Expected: OK" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: OK. See checker-tests.log for checker comment"
    read
fi
echo "Running test #3" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/03 files/tests/checker-tests/03.o files/tests/checker-tests/03.a 2>> checker-tests.log
if [ "$?" -ne "0" ]; then
    echo "Checker returned incorrect verdict. Expected: OK" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: OK. See checker-tests.log for checker comment"
    read
fi
echo "Running test #4" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/04 files/tests/checker-tests/04.o files/tests/checker-tests/04.a 2>> checker-tests.log
if [ "$?" -ne "2" ]; then
    echo "Checker returned incorrect verdict. Expected: Presentation error" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: Presentation error. See checker-tests.log for checker comment"
    read
fi
echo "Running test #5" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/05 files/tests/checker-tests/05.o files/tests/checker-tests/05.a 2>> checker-tests.log
if [ "$?" -ne "2" ]; then
    echo "Checker returned incorrect verdict. Expected: Presentation error" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: Presentation error. See checker-tests.log for checker comment"
    read
fi
echo "Running test #6" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/06 files/tests/checker-tests/06.o files/tests/checker-tests/06.a 2>> checker-tests.log
if [ "$?" -ne "2" ]; then
    echo "Checker returned incorrect verdict. Expected: Presentation error" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: Presentation error. See checker-tests.log for checker comment"
    read
fi
echo "Running test #7" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/07 files/tests/checker-tests/07.o files/tests/checker-tests/07.a 2>> checker-tests.log
if [ "$?" -ne "0" ]; then
    echo "Checker returned incorrect verdict. Expected: OK" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: OK. See checker-tests.log for checker comment"
    read
fi
echo "Running test #8" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/08 files/tests/checker-tests/08.o files/tests/checker-tests/08.a 2>> checker-tests.log
if [ "$?" -ne "1" ]; then
    echo "Checker returned incorrect verdict. Expected: Wrong answer" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: Wrong answer. See checker-tests.log for checker comment"
    read
fi
echo "Running test #9" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/09 files/tests/checker-tests/09.o files/tests/checker-tests/09.a 2>> checker-tests.log
if [ "$?" -ne "2" ]; then
    echo "Checker returned incorrect verdict. Expected: Presentation error" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: Presentation error. See checker-tests.log for checker comment"
    read
fi
echo "Running test #10" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/10 files/tests/checker-tests/10.o files/tests/checker-tests/10.a 2>> checker-tests.log
if [ "$?" -ne "2" ]; then
    echo "Checker returned incorrect verdict. Expected: Presentation error" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: Presentation error. See checker-tests.log for checker comment"
    read
fi
echo "Running test #11" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/11 files/tests/checker-tests/11.o files/tests/checker-tests/11.a 2>> checker-tests.log
if [ "$?" -ne "2" ]; then
    echo "Checker returned incorrect verdict. Expected: Presentation error" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: Presentation error. See checker-tests.log for checker comment"
    read
fi
echo "Running test #12" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/12 files/tests/checker-tests/12.o files/tests/checker-tests/12.a 2>> checker-tests.log
if [ "$?" -ne "2" ]; then
    echo "Checker returned incorrect verdict. Expected: Presentation error" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: Presentation error. See checker-tests.log for checker comment"
    read
fi
echo "Running test #13" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/13 files/tests/checker-tests/13.o files/tests/checker-tests/13.a 2>> checker-tests.log
if [ "$?" -ne "2" ]; then
    echo "Checker returned incorrect verdict. Expected: Presentation error" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: Presentation error. See checker-tests.log for checker comment"
    read
fi
echo "Running test #14" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/14 files/tests/checker-tests/14.o files/tests/checker-tests/14.a 2>> checker-tests.log
if [ "$?" -ne "2" ]; then
    echo "Checker returned incorrect verdict. Expected: Presentation error" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: Presentation error. See checker-tests.log for checker comment"
    read
fi
echo "Running test #15" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/15 files/tests/checker-tests/15.o files/tests/checker-tests/15.a 2>> checker-tests.log
if [ "$?" -ne "1" ]; then
    echo "Checker returned incorrect verdict. Expected: Wrong answer" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: Wrong answer. See checker-tests.log for checker comment"
    read
fi
echo "Running test #16" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/16 files/tests/checker-tests/16.o files/tests/checker-tests/16.a 2>> checker-tests.log
if [ "$?" -ne "2" ]; then
    echo "Checker returned incorrect verdict. Expected: Presentation error" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: Presentation error. See checker-tests.log for checker comment"
    read
fi
echo "Running test #17" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/17 files/tests/checker-tests/17.o files/tests/checker-tests/17.a 2>> checker-tests.log
if [ "$?" -ne "2" ]; then
    echo "Checker returned incorrect verdict. Expected: Presentation error" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: Presentation error. See checker-tests.log for checker comment"
    read
fi
echo "Running test #18" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/18 files/tests/checker-tests/18.o files/tests/checker-tests/18.a 2>> checker-tests.log
if [ "$?" -ne "2" ]; then
    echo "Checker returned incorrect verdict. Expected: Presentation error" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: Presentation error. See checker-tests.log for checker comment"
    read
fi
echo "Running test #19" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/19 files/tests/checker-tests/19.o files/tests/checker-tests/19.a 2>> checker-tests.log
if [ "$?" -ne "2" ]; then
    echo "Checker returned incorrect verdict. Expected: Presentation error" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: Presentation error. See checker-tests.log for checker comment"
    read
fi
echo "Running test #20" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/20 files/tests/checker-tests/20.o files/tests/checker-tests/20.a 2>> checker-tests.log
if [ "$?" -ne "2" ]; then
    echo "Checker returned incorrect verdict. Expected: Presentation error" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: Presentation error. See checker-tests.log for checker comment"
    read
fi
echo "Running test #21" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/21 files/tests/checker-tests/21.o files/tests/checker-tests/21.a 2>> checker-tests.log
if [ "$?" -ne "2" ]; then
    echo "Checker returned incorrect verdict. Expected: Presentation error" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: Presentation error. See checker-tests.log for checker comment"
    read
fi
echo "Running test #22" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/22 files/tests/checker-tests/22.o files/tests/checker-tests/22.a 2>> checker-tests.log
if [ "$?" -ne "2" ]; then
    echo "Checker returned incorrect verdict. Expected: Presentation error" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: Presentation error. See checker-tests.log for checker comment"
    read
fi
echo "Running test #23" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/23 files/tests/checker-tests/23.o files/tests/checker-tests/23.a 2>> checker-tests.log
if [ "$?" -ne "2" ]; then
    echo "Checker returned incorrect verdict. Expected: Presentation error" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: Presentation error. See checker-tests.log for checker comment"
    read
fi
echo "Running test #24" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/24 files/tests/checker-tests/24.o files/tests/checker-tests/24.a 2>> checker-tests.log
if [ "$?" -ne "2" ]; then
    echo "Checker returned incorrect verdict. Expected: Presentation error" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: Presentation error. See checker-tests.log for checker comment"
    read
fi
echo "Running test #25" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/25 files/tests/checker-tests/25.o files/tests/checker-tests/25.a 2>> checker-tests.log
if [ "$?" -ne "3" ]; then
    echo "Checker returned incorrect verdict. Expected: Crashed" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: Crashed. See checker-tests.log for checker comment"
    read
fi
echo "Running test #26" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/26 files/tests/checker-tests/26.o files/tests/checker-tests/26.a 2>> checker-tests.log
if [ "$?" -ne "3" ]; then
    echo "Checker returned incorrect verdict. Expected: Crashed" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: Crashed. See checker-tests.log for checker comment"
    read
fi
echo "Running test #27" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/27 files/tests/checker-tests/27.o files/tests/checker-tests/27.a 2>> checker-tests.log
if [ "$?" -ne "1" ]; then
    echo "Checker returned incorrect verdict. Expected: Wrong answer" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: Wrong answer. See checker-tests.log for checker comment"
    read
fi
echo "Running test #28" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/28 files/tests/checker-tests/28.o files/tests/checker-tests/28.a 2>> checker-tests.log
if [ "$?" -ne "0" ]; then
    echo "Checker returned incorrect verdict. Expected: OK" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: OK. See checker-tests.log for checker comment"
    read
fi
echo "Running test #29" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/29 files/tests/checker-tests/29.o files/tests/checker-tests/29.a 2>> checker-tests.log
if [ "$?" -ne "0" ]; then
    echo "Checker returned incorrect verdict. Expected: OK" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: OK. See checker-tests.log for checker comment"
    read
fi
echo "Running test #30" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/30 files/tests/checker-tests/30.o files/tests/checker-tests/30.a 2>> checker-tests.log
if [ "$?" -ne "0" ]; then
    echo "Checker returned incorrect verdict. Expected: OK" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: OK. See checker-tests.log for checker comment"
    read
fi
echo "Running test #31" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/31 files/tests/checker-tests/31.o files/tests/checker-tests/31.a 2>> checker-tests.log
if [ "$?" -ne "0" ]; then
    echo "Checker returned incorrect verdict. Expected: OK" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: OK. See checker-tests.log for checker comment"
    read
fi
echo "Running test #32" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/32 files/tests/checker-tests/32.o files/tests/checker-tests/32.a 2>> checker-tests.log
if [ "$?" -ne "0" ]; then
    echo "Checker returned incorrect verdict. Expected: OK" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: OK. See checker-tests.log for checker comment"
    read
fi
echo "Running test #33" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/33 files/tests/checker-tests/33.o files/tests/checker-tests/33.a 2>> checker-tests.log
if [ "$?" -ne "2" ]; then
    echo "Checker returned incorrect verdict. Expected: Presentation error" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: Presentation error. See checker-tests.log for checker comment"
    read
fi
echo "Running test #34" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/34 files/tests/checker-tests/34.o files/tests/checker-tests/34.a 2>> checker-tests.log
if [ "$?" -ne "2" ]; then
    echo "Checker returned incorrect verdict. Expected: Presentation error" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: Presentation error. See checker-tests.log for checker comment"
    read
fi
echo "Running test #35" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/35 files/tests/checker-tests/35.o files/tests/checker-tests/35.a 2>> checker-tests.log
if [ "$?" -ne "0" ]; then
    echo "Checker returned incorrect verdict. Expected: OK" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: OK. See checker-tests.log for checker comment"
    read
fi
echo "Running test #36" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/36 files/tests/checker-tests/36.o files/tests/checker-tests/36.a 2>> checker-tests.log
if [ "$?" -ne "0" ]; then
    echo "Checker returned incorrect verdict. Expected: OK" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: OK. See checker-tests.log for checker comment"
    read
fi
echo "Running test #37" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/37 files/tests/checker-tests/37.o files/tests/checker-tests/37.a 2>> checker-tests.log
if [ "$?" -ne "0" ]; then
    echo "Checker returned incorrect verdict. Expected: OK" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: OK. See checker-tests.log for checker comment"
    read
fi
echo "Running test #38" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/38 files/tests/checker-tests/38.o files/tests/checker-tests/38.a 2>> checker-tests.log
if [ "$?" -ne "0" ]; then
    echo "Checker returned incorrect verdict. Expected: OK" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: OK. See checker-tests.log for checker comment"
    read
fi
echo "Running test #39" 1>> checker-tests.log
echo "Checker comment:" 1>> checker-tests.log
wine check.exe files/tests/checker-tests/39 files/tests/checker-tests/39.o files/tests/checker-tests/39.a 2>> checker-tests.log
if [ "$?" -ne "0" ]; then
    echo "Checker returned incorrect verdict. Expected: OK" 1>> checker-tests.log
    echo "Checker returned incorrect verdict. Expected: OK. See checker-tests.log for checker comment"
    read
fi
rm -f checker-tests.log
echo "Checker test(s) finished"
