/**
 *    author:  tourist
 *    created: 06.10.2022 19:45:46       
**/
#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

const double M = 1e13;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  cin >> n;
  vector<int> x(n), y(n);
  for (int i = 0; i < n; i++) {
    cin >> x[i] >> y[i];
  }
  vector<array<double, 3>> fun;
  for (int i = 1; i < n - 1; i++) {
    double a = (double) (y[i] - y[i - 1]) / (x[i] - x[i - 1]);
    double b = y[i] - a * x[i];
    double c = (double) (y[i + 1] - y[i]) / (x[i + 1] - x[i]);
    double d = y[i] - c * x[i];
    fun.push_back({a < c ? 1.0 : -1.0, (c - a) / 2, (d - b) / 2});
  }
  {
    int i = 1;
    double a = (double) (y[i] - y[i - 1]) / (x[i] - x[i - 1]);
    double b = y[i] - a * x[i];
    i = n - 2;
    double c = (double) (y[i + 1] - y[i]) / (x[i + 1] - x[i]);
    double d = y[i] - c * x[i];
    double e = (a + c) / 2;
    double f = (b + d) / 2;
    fun.push_back({1.0, e, f + M});
    fun.push_back({-1.0, 0.0, M});
  }
  cout << fixed << setprecision(17);
  for (int i = 0; i < n; i++) {
    if (i > 0 || fun[i][0] < 0) {
      cout << (fun[i][0] > 0 ? "+" : "-");
    }
    cout << "|" << fun[i][1] << "x" << (fun[i][2] >= 0 ? "+" : "-") << abs(fun[i][2]) << "|";
  }
  cout << '\n';
  return 0;
}
